package io.swagger.client

import io.swagger.client.api._

import com.wordnik.swagger.client._

import java.io.Closeable

class SwaggerClient(config: SwaggerConfig) extends Closeable {
  val locator = config.locator
  val name = config.name

  private[this] val client = transportClient

  protected def transportClient: TransportClient = new RestClient(config)
  
  val  = new DefaultApi(client, config)
  
  val authAPI = new AuthAPIApi(client, config)
  
  val dNS = new DNSApi(client, config)
  
  val hostingftpAPI = new HostingftpAPIApi(client, config)
  
  val hostingiisAPI = new HostingiisAPIApi(client, config)
  
  val microsoftSQLServer = new MicrosoftSQLServerApi(client, config)
  
  val mySQLPostgres = new MySQLPostgresApi(client, config)
  
  val vDSHyperVOpenVZ = new VDSHyperVOpenVZApi(client, config)
  

  def close() {
    client.close()
  }
}
