package io.swagger.client.api

import com.wordnik.swagger.client._
import scala.concurrent.Future
import collection.mutable

class AuthAPIApi(client: TransportClient, config: SwaggerConfig) extends ApiClient(client, config) {

  def authLoginPost(login: String,
      salt: String,
      response: String)(implicit reader: ClientResponseReader[String]): Future[String] = {
    // create path and map variables
    val path = (addFmt("/auth/login"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (login != null) queryParams += "login" -> login.toString

    if (salt != null) queryParams += "salt" -> salt.toString

    if (response != null) queryParams += "response" -> response.toString



    val resFuture = client.submit("POST", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def authStartGet(login: String)(implicit reader: ClientResponseReader[String]): Future[String] = {
    // create path and map variables
    val path = (addFmt("/auth/start"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (login != null) queryParams += "login" -> login.toString



    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }


}
