package io.swagger.client.api

import io.swagger.client.model.Inline_response_200_3
import io.swagger.client.model.Inline_response_200_4
import com.wordnik.swagger.client._
import scala.concurrent.Future
import collection.mutable

class DNSApi(client: TransportClient, config: SwaggerConfig) extends ApiClient(client, config) {

  def dnsAddGet(token: String,
      addDnsZone: String,
      addDnsRecord: Option[String] = None,
      iisSiteForDns: Option[String] = None,
      bindOnly: Option[Boolean] = None
      )(implicit reader: ClientResponseReader[String]): Future[String] = {
    // create path and map variables
    val path = (addFmt("/dns/add"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (token != null) queryParams += "_token_" -> token.toString

    if (addDnsZone != null) queryParams += "add_dns_zone" -> addDnsZone.toString

    if (addDnsRecord != null) addDnsRecord.foreach { v => queryParams += "add_dns_record" -> v.toString }

    if (iisSiteForDns != null) iisSiteForDns.foreach { v => queryParams += "iis_site_for_dns" -> v.toString }

    if (bindOnly != null) bindOnly.foreach { v => queryParams += "bind_only" -> v.toString }



    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def dnsBindGet(token: String,
      key: Integer,
      bindTo: Option[String] = None
      )(implicit reader: ClientResponseReader[String]): Future[String] = {
    // create path and map variables
    val path = (addFmt("/dns/bind"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (token != null) queryParams += "_token_" -> token.toString

    if (key != null) queryParams += "_key_" -> key.toString

    if (bindTo != null) bindTo.foreach { v => queryParams += "bind_to" -> v.toString }



    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def dnsListGet(token: String)(implicit reader: ClientResponseReader[List[Inline_response_200_3]]): Future[List[Inline_response_200_3]] = {
    // create path and map variables
    val path = (addFmt("/dns/list"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (token != null) queryParams += "_token_" -> token.toString



    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def dnsProlongListGet(token: String)(implicit reader: ClientResponseReader[List[Inline_response_200_4]]): Future[List[Inline_response_200_4]] = {
    // create path and map variables
    val path = (addFmt("/dns/prolong/list"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (token != null) queryParams += "_token_" -> token.toString



    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def dnsRawGet(token: String,
      key: Integer,
      sDel: Integer,
      sAdd: Integer,
      dnsType: String,
      dnsName: String,
      dnsValue: String)(implicit reader: ClientResponseReader[String]): Future[String] = {
    // create path and map variables
    val path = (addFmt("/dns/raw"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (token != null) queryParams += "_token_" -> token.toString

    if (key != null) queryParams += "_key_" -> key.toString

    if (sDel != null) queryParams += "s_del" -> sDel.toString

    if (sAdd != null) queryParams += "s_add" -> sAdd.toString

    if (dnsType != null) queryParams += "dns_type" -> dnsType.toString

    if (dnsName != null) queryParams += "dns_name" -> dnsName.toString

    if (dnsValue != null) queryParams += "dns_value" -> dnsValue.toString



    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def dnsRawManagedmxGet(token: String,
      key: Integer,
      managedMx: Integer,
      updManagedMx: Integer)(implicit reader: ClientResponseReader[String]): Future[String] = {
    // create path and map variables
    val path = (addFmt("/dns/raw/managedmx"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (token != null) queryParams += "_token_" -> token.toString

    if (key != null) queryParams += "_key_" -> key.toString

    if (managedMx != null) queryParams += "managed_mx" -> managedMx.toString

    if (updManagedMx != null) queryParams += "upd_managed_mx" -> updManagedMx.toString



    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }


}
