package io.swagger.client.api

import io.swagger.client.model.Number
import io.swagger.client.model.Inline_response_200
import io.swagger.client.model.Inline_response_200_1
import io.swagger.client.model. 
import io.swagger.client.model.Inline_response_200_4
import io.swagger.client.model.Inline_response_200_5
import io.swagger.client.model.Inline_response_200_6
import io.swagger.client.model.Inline_response_200_10
import io.swagger.client.model.Inline_response_200_14
import com.wordnik.swagger.client._
import scala.concurrent.Future
import collection.mutable

class DefaultApi(client: TransportClient, config: SwaggerConfig) extends ApiClient(client, config) {

  def balanceGet(token: String)(implicit reader: ClientResponseReader[Number]): Future[Number] = {
    // create path and map variables
    val path = (addFmt("/balance"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (token != null) queryParams += "_token_" -> token.toString



    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def balanceLicGet(token: String)(implicit reader: ClientResponseReader[Number]): Future[Number] = {
    // create path and map variables
    val path = (addFmt("/balance.lic"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (token != null) queryParams += "_token_" -> token.toString



    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def billingDebtGet(token: String)(implicit reader: ClientResponseReader[List[Inline_response_200]]): Future[List[Inline_response_200]] = {
    // create path and map variables
    val path = (addFmt("/billing/debt"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (token != null) queryParams += "_token_" -> token.toString



    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def billingInfoGet(token: String)(implicit reader: ClientResponseReader[List[Inline_response_200_1]]): Future[List[Inline_response_200_1]] = {
    // create path and map variables
    val path = (addFmt("/billing/info"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (token != null) queryParams += "_token_" -> token.toString



    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def billingLimitsGet(token: String)(implicit reader: ClientResponseReader[ ]): Future[ ] = {
    // create path and map variables
    val path = (addFmt("/billing/limits"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (token != null) queryParams += "_token_" -> token.toString



    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def dnsProlongListGet(token: String)(implicit reader: ClientResponseReader[List[Inline_response_200_4]]): Future[List[Inline_response_200_4]] = {
    // create path and map variables
    val path = (addFmt("/dns/prolong/list"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (token != null) queryParams += "_token_" -> token.toString



    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def emailAddGet(token: String,
      addEmail: String)(implicit reader: ClientResponseReader[String]): Future[String] = {
    // create path and map variables
    val path = (addFmt("/email/add"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (token != null) queryParams += "_token_" -> token.toString

    if (addEmail != null) queryParams += "add_email" -> addEmail.toString



    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def emailAliasDeleteGet(token: String,
      key: String)(implicit reader: ClientResponseReader[String]): Future[String] = {
    // create path and map variables
    val path = (addFmt("/email/alias/delete"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (token != null) queryParams += "_token_" -> token.toString

    if (key != null) queryParams += "_key_" -> key.toString



    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def emailAliasListGet(token: String)(implicit reader: ClientResponseReader[List[Inline_response_200_5]]): Future[List[Inline_response_200_5]] = {
    // create path and map variables
    val path = (addFmt("/email/alias/list"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (token != null) queryParams += "_token_" -> token.toString



    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def emailDeleteGet(token: String,
      key: String)(implicit reader: ClientResponseReader[String]): Future[String] = {
    // create path and map variables
    val path = (addFmt("/email/delete"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (token != null) queryParams += "_token_" -> token.toString

    if (key != null) queryParams += "_key_" -> key.toString



    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def emailListGet(token: String)(implicit reader: ClientResponseReader[List[Inline_response_200_6]]): Future[List[Inline_response_200_6]] = {
    // create path and map variables
    val path = (addFmt("/email/list"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (token != null) queryParams += "_token_" -> token.toString



    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def updatesLastGet(token: String)(implicit reader: ClientResponseReader[Integer]): Future[Integer] = {
    // create path and map variables
    val path = (addFmt("/updates/last"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (token != null) queryParams += "_token_" -> token.toString



    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def updatesListGet(token: String,
      key: Integer)(implicit reader: ClientResponseReader[List[Inline_response_200_10]]): Future[List[Inline_response_200_10]] = {
    // create path and map variables
    val path = (addFmt("/updates/list"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (token != null) queryParams += "_token_" -> token.toString

    if (key != null) queryParams += "_key_" -> key.toString



    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def websiteDeleteGet(token: String,
      key: String)(implicit reader: ClientResponseReader[String]): Future[String] = {
    // create path and map variables
    val path = (addFmt("/website/delete"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (token != null) queryParams += "_token_" -> token.toString

    if (key != null) queryParams += "_key_" -> key.toString



    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def websiteListGet(token: String)(implicit reader: ClientResponseReader[List[Inline_response_200_14]]): Future[List[Inline_response_200_14]] = {
    // create path and map variables
    val path = (addFmt("/website/list"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (token != null) queryParams += "_token_" -> token.toString



    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }


}
