package io.swagger.client.api

import io.swagger.client.model.Inline_response_200_11
import io.swagger.client.model.Inline_response_200_12
import io.swagger.client.model.Inline_response_200_13
import com.wordnik.swagger.client._
import scala.concurrent.Future
import collection.mutable

class VDSHyperVOpenVZApi(client: TransportClient, config: SwaggerConfig) extends ApiClient(client, config) {

  def vdsCreateGet(token: String,
      _type: Option[String] = None,
      crHvmem: Option[Integer] = None,
      crHvdsk: Option[Integer] = None,
      crHvcpu: Option[Integer] = None,
      template: Option[String] = None,
      forceMemo: Option[String] = None,
      hv1gbPanelVersion: Option[String] = None,
      panelInstall: Option[Boolean] = None,
      crSsd1: Option[Boolean] = None,
      crHvAllSystem: Option[Boolean] = None
      )(implicit reader: ClientResponseReader[String]): Future[String] = {
    // create path and map variables
    val path = (addFmt("/vds/create"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (token != null) queryParams += "_token_" -> token.toString

    if (_type != null) _type.foreach { v => queryParams += "type" -> v.toString }

    if (crHvmem != null) crHvmem.foreach { v => queryParams += "cr_hvmem" -> v.toString }

    if (crHvdsk != null) crHvdsk.foreach { v => queryParams += "cr_hvdsk" -> v.toString }

    if (crHvcpu != null) crHvcpu.foreach { v => queryParams += "cr_hvcpu" -> v.toString }

    if (template != null) template.foreach { v => queryParams += "template" -> v.toString }

    if (forceMemo != null) forceMemo.foreach { v => queryParams += "force_memo" -> v.toString }

    if (hv1gbPanelVersion != null) hv1gbPanelVersion.foreach { v => queryParams += "hv_1gb_panel_version" -> v.toString }

    if (panelInstall != null) panelInstall.foreach { v => queryParams += "panel_install" -> v.toString }

    if (crSsd1 != null) crSsd1.foreach { v => queryParams += "cr_ssd1" -> v.toString }

    if (crHvAllSystem != null) crHvAllSystem.foreach { v => queryParams += "cr_hv_all_system" -> v.toString }



    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def vdsDeleteGet(token: String,
      key: Integer,
      forceCritical: Option[Boolean] = None
      )(implicit reader: ClientResponseReader[String]): Future[String] = {
    // create path and map variables
    val path = (addFmt("/vds/delete"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (token != null) queryParams += "_token_" -> token.toString

    if (key != null) queryParams += "_key_" -> key.toString

    if (forceCritical != null) forceCritical.foreach { v => queryParams += "force_critical" -> v.toString }



    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def vdsIpAddGet(token: String,
      key: Integer)(implicit reader: ClientResponseReader[String]): Future[String] = {
    // create path and map variables
    val path = (addFmt("/vds/ip/add"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (token != null) queryParams += "_token_" -> token.toString

    if (key != null) queryParams += "_key_" -> key.toString



    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def vdsIpDeleteGet(token: String,
      key: Integer,
      delIp: String)(implicit reader: ClientResponseReader[String]): Future[String] = {
    // create path and map variables
    val path = (addFmt("/vds/ip/delete"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (token != null) queryParams += "_token_" -> token.toString

    if (key != null) queryParams += "_key_" -> key.toString

    if (delIp != null) queryParams += "del_ip" -> delIp.toString



    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def vdsIpListGet(token: String,
      key: Option[Integer] = None
      )(implicit reader: ClientResponseReader[List[Inline_response_200_11]]): Future[List[Inline_response_200_11]] = {
    // create path and map variables
    val path = (addFmt("/vds/ip/list"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (token != null) queryParams += "_token_" -> token.toString

    if (key != null) key.foreach { v => queryParams += "_key_" -> v.toString }



    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def vdsListGet(token: String,
      key: Option[Integer] = None
      )(implicit reader: ClientResponseReader[List[Inline_response_200_12]]): Future[List[Inline_response_200_12]] = {
    // create path and map variables
    val path = (addFmt("/vds/list"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (token != null) queryParams += "_token_" -> token.toString

    if (key != null) key.foreach { v => queryParams += "_key_" -> v.toString }



    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def vdsRebootGet(token: String,
      key: Integer)(implicit reader: ClientResponseReader[String]): Future[String] = {
    // create path and map variables
    val path = (addFmt("/vds/reboot"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (token != null) queryParams += "_token_" -> token.toString

    if (key != null) queryParams += "_key_" -> key.toString



    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def vdsTemplatesListGet(token: String)(implicit reader: ClientResponseReader[List[Inline_response_200_13]]): Future[List[Inline_response_200_13]] = {
    // create path and map variables
    val path = (addFmt("/vds/templates-list"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (token != null) queryParams += "_token_" -> token.toString



    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }

  def vdsUpdateGet(token: String,
      key: Integer,
      crHvmem: Option[Integer] = None,
      crHvdsk: Option[Integer] = None,
      crHvcpu: Option[Integer] = None
      )(implicit reader: ClientResponseReader[String]): Future[String] = {
    // create path and map variables
    val path = (addFmt("/vds/update"))

    // query params
    val queryParams = new mutable.HashMap[String, String]
    val headerParams = new mutable.HashMap[String, String]

    if (token != null) queryParams += "_token_" -> token.toString

    if (key != null) queryParams += "_key_" -> key.toString

    if (crHvmem != null) crHvmem.foreach { v => queryParams += "cr_hvmem" -> v.toString }

    if (crHvdsk != null) crHvdsk.foreach { v => queryParams += "cr_hvdsk" -> v.toString }

    if (crHvcpu != null) crHvcpu.foreach { v => queryParams += "cr_hvcpu" -> v.toString }



    val resFuture = client.submit("GET", path, queryParams.toMap, headerParams.toMap, "")
    resFuture flatMap { resp =>
      process(reader.read(resp))
    }
  }


}
